//
//  LinkPopUpButton.swift
//  CustomControls
//
//  Created by Evan Owen on 5/25/16.
//  Copyright © 2016 Evan Owen. All rights reserved.
//

import Cocoa

//@objc protocol LinkPopUpButtonDelegate {
//    func clickedPopUpButtonLink(popUpButton: NSPopUpButton)
//}

class LinkPopUpButton: NSPopUpButton {

    var button: NSButton!
//    @IBOutlet var delegate: AnyObject?
    var linkIdentifier: String?
    @IBOutlet var windowController: ROMWindowController?

    var buttonFrame: NSRect {

        // TODO: right to left reading order
        if userInterfaceLayoutDirection == .LeftToRight {
            
        } else {
            
        }
        
        switch controlSize {
        case .RegularControlSize:
            return NSMakeRect(frame.width - 37, 5.0, 15.0, 15.0)
        case .SmallControlSize:
            return NSMakeRect(frame.width - 34, 3.0, 14.0, 14.0)
        case .MiniControlSize:
            return NSMakeRect(frame.width - 28, 2.0, 11.0, 11.0)
        }
    }

    override init(frame frameRect: NSRect) {
        super.init(frame: frameRect)
        initButton()
    }

    required init?(coder: NSCoder) {
        super.init(coder: coder)
        initButton()
    }

    func initButton() {
        
        button = NSButton(frame: buttonFrame)
        button.setButtonType(NSButtonType.MomentaryChangeButton)
        button.bezelStyle = NSBezelStyle.InlineBezelStyle
        button.bordered = false
        button.title = ""
        button.target = self
        button.action = #selector(LinkPopUpButton.buttonAction(_:))
        button.bind("hidden", toObject: self, withKeyPath: "hidden", options: nil)
        button.bind("controlSize", toObject: self, withKeyPath: "controlSize", options: nil)
        button.bind("enabled", toObject: self, withKeyPath: "enabled", options: nil)

//        let linkImage = NSImage(named: NSImageNameFollowLinkFreestandingTemplate)!
//        let buttonImage = NSImage(size: button.frame.size)
//        buttonImage.lockFocus()
//        linkImage.drawInRect(NSMakeRect(0, 0, buttonImage.size.width, buttonImage.size.height), fromRect: NSZeroRect, operation: NSCompositingOperation.CompositeSourceOver, fraction: 1.0)
//        buttonImage.template = true
//        buttonImage.unlockFocus()
//        button.image = buttonImage
        
        addSubview(button)
    }
    
    override func awakeFromNib() {
        let linkImage = NSImage(named: NSImageNameFollowLinkFreestandingTemplate)!
        let buttonImage = NSImage(size: button.frame.size)
        buttonImage.lockFocus()
        linkImage.drawInRect(NSMakeRect(0, 0, buttonImage.size.width, buttonImage.size.height), fromRect: NSZeroRect, operation: NSCompositingOperation.CompositeSourceOver, fraction: 1.0)
        buttonImage.template = true
        buttonImage.unlockFocus()
        button.image = buttonImage
    }
    
//    override var image: NSImage? {
//        get {
//            let linkImage = NSImage(named: NSImageNameFollowLinkFreestandingTemplate)!
//            let buttonImage = NSImage(size: button.frame.size)
//            buttonImage.lockFocus()
//            linkImage.drawInRect(NSMakeRect(0, 0, buttonImage.size.width, buttonImage.size.height), fromRect: NSZeroRect, operation: NSCompositingOperation.CompositeSourceOver, fraction: 1.0)
//            buttonImage.template = true
//            buttonImage.unlockFocus()
//            return buttonImage
//        } set {
//            
//        }
//    }
    
    override func resizeSubviewsWithOldSize(oldSize: NSSize) {
        button.frame = buttonFrame
    }
    
    @IBAction func buttonAction(sender: AnyObject?) {
        
        // get the link identifier and the selected index
        guard let identifier = linkIdentifier else { return }
        guard let selectedIndex = selectedItem?.representedObject as? Int else { return }
        
        // select the linked object
        windowController?.selectObjectAtIndex(selectedIndex, inArray: windowController?.rom.valueForKey(identifier) as? ROMArray)
        
//        if let object = windowController?.rom?.valueForKey(identifier) {
//            windowController?.selectObject(object)
//        } else {
//            delegate?.clickedPopUpButtonLink(self)
//        }
    }
    
}
