//
//  AppDelegate.swift
//  FF6Tools
//
//  Created by Evan Owen on 8/18/16.
//  Copyright © 2016 Evan Owen. All rights reserved.
//

import Cocoa

let backgroundColorKey = "ROMBackgroundColor"
let imageInterpolationKey = "ROMImageInterpolation"
let autoExpandKey = "ROMAutoExpand"
let createLogKey = "ROMCreateLog"

@NSApplicationMain
class AppDelegate: NSObject, NSApplicationDelegate {
    
    var preferences = NSWindowController(windowNibName: NSNib.Name(rawValue: "Preferences"))
    
    @IBAction func showPreferences(_ sender: AnyObject) {
        preferences.showWindow(self)
        preferences.window?.makeKeyAndOrderFront(self)
    }
    
    func applicationWillFinishLaunching(_ notification: Notification) {
        let _ = FF6DocumentController()
    }
    
    func applicationDidFinishLaunching(_ aNotification: Notification) {
        // Insert code here to initialize your application
    }

    func applicationWillTerminate(_ aNotification: Notification) {
        // Insert code here to tear down your application
    }

    func applicationShouldOpenUntitledFile(_ sender: NSApplication) -> Bool {
        return false
    }
    
    override init() {
        super.init()
        
        let orangeColorData = NSArchiver.archivedData(withRootObject: NSColor.orange)
        let defaults: [String : Any] = [
            backgroundColorKey : orangeColorData,
            imageInterpolationKey : NSImageInterpolation.none.rawValue,
            createLogKey : true,
            autoExpandKey : true]
        UserDefaults.standard.register(defaults: defaults)
    }
}

class FF6DocumentController: NSDocumentController {
    
    // this hides the "+" button in the tab bar so you can't try to create a new ROM from nothing
    override func responds(to aSelector: Selector!) -> Bool {
        if #available(OSX 10.12, *), aSelector == #selector(NSResponder.newWindowForTab(_:)) {
            return false
        }
        return super.responds(to: aSelector)
    }
}
