//
//  TextStepperCell.swift
//  CustomControls
//
//  Created by Evan Owen on 5/22/16.
//  Copyright © 2016 Evan Owen. All rights reserved.
//

import Cocoa

class TextStepperCell: NSTextFieldCell {
    
//    var stepperCell: NSStepperCell!
    var stepperWidth: CGFloat {
        switch controlSize {
        case .regular:
            return 16.0
        case .small:
            return 14.0
        case .mini:
            return 12.0
        }
    }
    
//    override init(textCell aString: String) {
//        super.init(textCell: aString)
//        initStepper()
//    }
//    
//    override init(imageCell image: NSImage?) {
//        super.init(imageCell: image)
//        initStepper()
//    }
//    
//    required init?(coder aDecoder: NSCoder) {
//        super.init(coder: aDecoder)
//        initStepper()
//    }
//    
//    func initStepper() {
//        stepperCell = NSStepperCell()
//        stepperCell.bordered = false
//        stepperCell.enabled = true
//        stepperCell.editable = true
//        stepperCell.controlSize = self.controlSize
//        stepperCell.controlView = self.controlView
//        stepperCell.target = self
//        stepperCell.action = #selector(TextStepperCell.stepperAction(_:))
//        stepperCell.objectValue = objectValue
//        if let numberFormatter = self.formatter as? NSNumberFormatter, let max = numberFormatter.maximum, let min = numberFormatter.minimum {
//            stepperCell.maxValue = Double(max)
//            stepperCell.minValue = Double(min)
//        }
//    }
//    
//    func stepperAction(sender: AnyObject) {
//        objectValue = stepperCell.objectValue
//    }
    
    override func draw(withFrame cellFrame: NSRect, in controlView: NSView) {
        let textRect = NSMakeRect(cellFrame.minX, cellFrame.minY, cellFrame.width - stepperWidth, cellFrame.height)
        
//        let stepperRect = NSMakeRect(cellFrame.maxX - stepperWidth, cellFrame.minY, stepperWidth, cellFrame.height)
//        stepperCell.drawWithFrame(stepperRect, inView: controlView)
        
        super.draw(withFrame: textRect, in: controlView)
    }

    override func resetCursorRect(_ cellFrame: NSRect, in controlView: NSView) {
        let textRect = NSMakeRect(cellFrame.minX, cellFrame.minY, cellFrame.width - stepperWidth, cellFrame.height)
        super.resetCursorRect(textRect, in: controlView)
    }
    
//    override func trackMouse(theEvent: NSEvent, inRect cellFrame: NSRect, ofView controlView: NSView, untilMouseUp flag: Bool) -> Bool {
//        let textRect = NSMakeRect(cellFrame.minX, cellFrame.minY, cellFrame.width - stepperWidth, cellFrame.height)
//        let stepperRect = NSMakeRect(cellFrame.maxX - stepperWidth, cellFrame.minY, stepperWidth, cellFrame.height)
//        
//        if stepperRect.contains(controlView.convertPoint(theEvent.locationInWindow, fromView: nil)) {
//            return stepperCell.trackMouse(theEvent, inRect: stepperRect, ofView: controlView, untilMouseUp: flag)
//        } else {
//            return super.trackMouse(theEvent, inRect: textRect, ofView: controlView, untilMouseUp: flag)
//        }
//    }
    
//    var trackingInStepper = false
    
//    override func startTrackingAt(startPoint: NSPoint, inView controlView: NSView) -> Bool {
//        let controlFrame = controlView.frame
//        let stepperRect = NSMakeRect(controlFrame.maxX - stepperWidth, controlFrame.minY, stepperWidth, controlFrame.height)
//
//        if stepperRect.contains(startPoint) {
//            trackingInStepper = true
//            return stepperCell.startTrackingAt(startPoint, inView: controlView)
//        } else {
//            trackingInStepper = false
//            return super.startTrackingAt(startPoint, inView: controlView)
//        }
//    }
//    
//    override func continueTracking(lastPoint: NSPoint, at currentPoint: NSPoint, inView controlView: NSView) -> Bool {
//        if trackingInStepper {
//            return stepperCell.continueTracking(lastPoint, at: currentPoint, inView: controlView)
//        } else {
//            return super.continueTracking(lastPoint, at: currentPoint, inView: controlView)
//        }
//    }
//    
//    override func stopTracking(lastPoint: NSPoint, at stopPoint: NSPoint, inView controlView: NSView, mouseIsUp flag: Bool) {
//        if trackingInStepper {
//            return stepperCell.stopTracking(lastPoint, at: stopPoint, inView: controlView, mouseIsUp: flag)
//        } else {
//            return super.stopTracking(lastPoint, at: stopPoint, inView: controlView, mouseIsUp: flag)
//        }
//    }
    
    override func menu(for event: NSEvent, in cellFrame: NSRect, of view: NSView) -> NSMenu? {
        let textRect = NSMakeRect(cellFrame.minX, cellFrame.minY, cellFrame.width - stepperWidth, cellFrame.height)
//        let stepperRect = NSMakeRect(cellFrame.maxX - stepperWidth, cellFrame.minY, stepperWidth, cellFrame.height)
        
        if textRect.contains(view.convert(event.locationInWindow, from: nil)) {
//            return stepperCell.menuForEvent(event, inRect: stepperRect, ofView: view)
//        } else {
            return super.menu(for: event, in: textRect, of: view)
//        }
        } else {
            return nil
        }
        
    }
    
    override func hitTest(for event: NSEvent, in cellFrame: NSRect, of controlView: NSView) -> NSCell.HitResult {
        let textRect = NSMakeRect(cellFrame.minX, cellFrame.minY, cellFrame.width - stepperWidth, cellFrame.height)
//        let stepperRect = NSMakeRect(cellFrame.maxX - stepperWidth, cellFrame.minY, stepperWidth, cellFrame.height)
        
        if textRect.contains(controlView.convert(event.locationInWindow, from: nil)) {
//            return stepperCell.hitTestForEvent(event, inRect: stepperRect, ofView: controlView)
//        } else {
            return super.hitTest(for: event, in: textRect, of: controlView)
        } else { return NSCell.HitResult() }
    }
    
    override func performClick(_ sender: Any?) {
//        stepperCell.performClick(sender)
        super.performClick(sender)
    }
    
//    override func drawInteriorWithFrame(cellFrame: NSRect, inView controlView: NSView) {
//        let textRect = NSMakeRect(cellFrame.minX, cellFrame.minY, cellFrame.width - stepperWidth, cellFrame.height)
//        let stepperRect = NSMakeRect(cellFrame.maxX - stepperWidth, cellFrame.minY, stepperWidth, cellFrame.height)
//        super.drawInteriorWithFrame(textRect, inView: controlView)
//        stepperCell.drawInteriorWithFrame(stepperRect, inView: controlView)
//    }

    override func highlight(_ flag: Bool, withFrame cellFrame: NSRect, in controlView: NSView) {
        let textRect = NSMakeRect(cellFrame.minX, cellFrame.minY, cellFrame.width - stepperWidth, cellFrame.height)
//        let stepperRect = NSMakeRect(cellFrame.maxX - stepperWidth, cellFrame.minY, stepperWidth, cellFrame.height)
        super.highlight(flag, withFrame: textRect, in: controlView)
//        stepperCell.highlight(flag, withFrame: stepperRect, inView: controlView)
    }
    
    override func highlightColor(withFrame cellFrame: NSRect, in controlView: NSView) -> NSColor? {
        let textRect = NSMakeRect(cellFrame.minX, cellFrame.minY, cellFrame.width - stepperWidth, cellFrame.height)
        return super.highlightColor(withFrame: textRect, in: controlView)
    }
    
    override func edit(withFrame aRect: NSRect, in controlView: NSView, editor textObj: NSText, delegate anObject: Any?, event theEvent: NSEvent?) {
        let textRect = NSMakeRect(aRect.minX, aRect.minY, aRect.width - stepperWidth, aRect.height)
//        let stepperRect = NSMakeRect(aRect.maxX - stepperWidth, aRect.minY, stepperWidth, aRect.height)
//        if stepperRect.contains(theEvent.locationInWindow) {
//            stepperCell.editWithFrame(stepperRect, inView: controlView, editor: textObj, delegate: anObject, event: theEvent)
//        } else {
            super.edit(withFrame: textRect, in: controlView, editor: textObj, delegate: anObject, event: theEvent)
//        }
    }
    
    override func select(withFrame aRect: NSRect, in controlView: NSView, editor textObj: NSText, delegate anObject: Any?, start selStart: Int, length selLength: Int) {
        let textRect = NSMakeRect(aRect.minX, aRect.minY, aRect.width - stepperWidth, aRect.height)
//        let stepperRect = NSMakeRect(aRect.maxX - stepperWidth, aRect.minY, stepperWidth, aRect.height)
        super.select(withFrame: textRect, in: controlView, editor: textObj, delegate: anObject, start: selStart, length: selLength)
//        stepperCell.selectWithFrame(stepperRect, inView: controlView, editor: textObj, delegate: anObject, start: selStart, length: selLength)
    }
    
    override func drawFocusRingMask(withFrame cellFrame: NSRect, in controlView: NSView) {
        let textRect = NSMakeRect(cellFrame.minX, cellFrame.minY, cellFrame.width - stepperWidth, cellFrame.height)
//        let stepperRect = NSMakeRect(cellFrame.maxX - stepperWidth, cellFrame.minY, stepperWidth, cellFrame.height)
        super.drawFocusRingMask(withFrame: textRect, in: controlView)
//        stepperCell.drawFocusRingMaskWithFrame(stepperRect, inView: controlView)
    }
    
//    override func drawingRectForBounds(theRect: NSRect) -> NSRect {
//        let textRect = NSMakeRect(theRect.minX, theRect.minY, theRect.width - stepperWidth, theRect.height)
//        return super.drawingRectForBounds(textRect)
//    }
    
//    override func imageRectForBounds(theRect: NSRect) -> NSRect {
//        let textRect = NSMakeRect(theRect.minX, theRect.minY, theRect.width - stepperWidth, theRect.height)
//        return super.drawingRectForBounds(textRect)
//    }
}
